/*!
 * @file kill.h
 * @brief Definition of a playable kill. Generated in the case when some playable dies
*/

#ifndef _KILL_H
#define _KILL_H

#include "base_object.h"

// FORWARD DECLARATION

class WorldEntity;
class Playable;

//! A representing a kill event
class Kill : public BaseObject
{

  public:
    Kill(WorldEntity* killer, WorldEntity* victim);
    Kill(WorldEntity* killer, Playable* victim);
    virtual ~Kill();

    /** @returns reference to the killer world entity, does not need to exist */
    inline WorldEntity* getKiller() { return this->killer; }
    /** @returns reference to the victim world entity, does not need to exist */
    inline WorldEntity* getVictim() { return this->victim; }

  private:
    WorldEntity*         killer;                   //!< reference to the killer world entity
    WorldEntity*         victim;                   //!< reference to the victim world entity

};

#endif /* _KILL_H */
